from ccxt.base.types import Entry


class ImplicitAPI:
    public_spot_get_public_time = publicSpotGetPublicTime = Entry('public/time', ['public', 'spot'], 'GET', {'cost': 1})
    public_spot_get_public_currencies = publicSpotGetPublicCurrencies = Entry('public/currencies', ['public', 'spot'], 'GET', {'cost': 1})
    public_spot_get_public_products = publicSpotGetPublicProducts = Entry('public/products', ['public', 'spot'], 'GET', {'cost': 1})
    public_spot_get_public_product = publicSpotGetPublicProduct = Entry('public/product', ['public', 'spot'], 'GET', {'cost': 1})
    public_spot_get_market_ticker = publicSpotGetMarketTicker = Entry('market/ticker', ['public', 'spot'], 'GET', {'cost': 1})
    public_spot_get_market_tickers = publicSpotGetMarketTickers = Entry('market/tickers', ['public', 'spot'], 'GET', {'cost': 1})
    public_spot_get_market_fills = publicSpotGetMarketFills = Entry('market/fills', ['public', 'spot'], 'GET', {'cost': 1})
    public_spot_get_market_fills_history = publicSpotGetMarketFillsHistory = Entry('market/fills-history', ['public', 'spot'], 'GET', {'cost': 2})
    public_spot_get_market_candles = publicSpotGetMarketCandles = Entry('market/candles', ['public', 'spot'], 'GET', {'cost': 1})
    public_spot_get_market_depth = publicSpotGetMarketDepth = Entry('market/depth', ['public', 'spot'], 'GET', {'cost': 1})
    public_spot_get_market_spot_vip_level = publicSpotGetMarketSpotVipLevel = Entry('market/spot-vip-level', ['public', 'spot'], 'GET', {'cost': 2})
    public_mix_get_market_contracts = publicMixGetMarketContracts = Entry('market/contracts', ['public', 'mix'], 'GET', {'cost': 1})
    public_mix_get_market_depth = publicMixGetMarketDepth = Entry('market/depth', ['public', 'mix'], 'GET', {'cost': 1})
    public_mix_get_market_ticker = publicMixGetMarketTicker = Entry('market/ticker', ['public', 'mix'], 'GET', {'cost': 1})
    public_mix_get_market_tickers = publicMixGetMarketTickers = Entry('market/tickers', ['public', 'mix'], 'GET', {'cost': 1})
    public_mix_get_market_fills = publicMixGetMarketFills = Entry('market/fills', ['public', 'mix'], 'GET', {'cost': 1})
    public_mix_get_market_candles = publicMixGetMarketCandles = Entry('market/candles', ['public', 'mix'], 'GET', {'cost': 1})
    public_mix_get_market_index = publicMixGetMarketIndex = Entry('market/index', ['public', 'mix'], 'GET', {'cost': 1})
    public_mix_get_market_funding_time = publicMixGetMarketFundingTime = Entry('market/funding-time', ['public', 'mix'], 'GET', {'cost': 1})
    public_mix_get_market_history_fundrate = publicMixGetMarketHistoryFundRate = Entry('market/history-fundRate', ['public', 'mix'], 'GET', {'cost': 1})
    public_mix_get_market_current_fundrate = publicMixGetMarketCurrentFundRate = Entry('market/current-fundRate', ['public', 'mix'], 'GET', {'cost': 1})
    public_mix_get_market_open_interest = publicMixGetMarketOpenInterest = Entry('market/open-interest', ['public', 'mix'], 'GET', {'cost': 1})
    public_mix_get_market_mark_price = publicMixGetMarketMarkPrice = Entry('market/mark-price', ['public', 'mix'], 'GET', {'cost': 1})
    public_mix_get_market_symbol_leverage = publicMixGetMarketSymbolLeverage = Entry('market/symbol-leverage', ['public', 'mix'], 'GET', {'cost': 1})
    public_mix_get_market_contract_vip_level = publicMixGetMarketContractVipLevel = Entry('market/contract-vip-level', ['public', 'mix'], 'GET', {'cost': 2})
    public_mix_get_market_fills_history = publicMixGetMarketFillsHistory = Entry('market/fills-history', ['public', 'mix'], 'GET', {'cost': 2})
    public_mix_get_market_querypositionlever = publicMixGetMarketQueryPositionLever = Entry('market/queryPositionLever', ['public', 'mix'], 'GET', {'cost': 1})
    private_spot_get_account_getinfo = privateSpotGetAccountGetInfo = Entry('account/getInfo', ['private', 'spot'], 'GET', {'cost': 20})
    private_spot_get_account_assets = privateSpotGetAccountAssets = Entry('account/assets', ['private', 'spot'], 'GET', {'cost': 2})
    private_spot_get_account_transferrecords = privateSpotGetAccountTransferRecords = Entry('account/transferRecords', ['private', 'spot'], 'GET', {'cost': 4})
    private_spot_get_wallet_deposit_address = privateSpotGetWalletDepositAddress = Entry('wallet/deposit-address', ['private', 'spot'], 'GET', {'cost': 4})
    private_spot_get_wallet_withdrawal_inner = privateSpotGetWalletWithdrawalInner = Entry('wallet/withdrawal-inner', ['private', 'spot'], 'GET', {'cost': 4})
    private_spot_get_wallet_withdrawal_list = privateSpotGetWalletWithdrawalList = Entry('wallet/withdrawal-list', ['private', 'spot'], 'GET', {'cost': 1})
    private_spot_get_wallet_deposit_list = privateSpotGetWalletDepositList = Entry('wallet/deposit-list', ['private', 'spot'], 'GET', {'cost': 1})
    private_spot_post_account_bills = privateSpotPostAccountBills = Entry('account/bills', ['private', 'spot'], 'POST', {'cost': 2})
    private_spot_post_account_sub_account_spot_assets = privateSpotPostAccountSubAccountSpotAssets = Entry('account/sub-account-spot-assets', ['private', 'spot'], 'POST', {'cost': 200})
    private_spot_post_trade_orders = privateSpotPostTradeOrders = Entry('trade/orders', ['private', 'spot'], 'POST', {'cost': 2})
    private_spot_post_trade_batch_orders = privateSpotPostTradeBatchOrders = Entry('trade/batch-orders', ['private', 'spot'], 'POST', {'cost': 4})
    private_spot_post_trade_cancel_order = privateSpotPostTradeCancelOrder = Entry('trade/cancel-order', ['private', 'spot'], 'POST', {'cost': 2})
    private_spot_post_trade_cancel_batch_orders = privateSpotPostTradeCancelBatchOrders = Entry('trade/cancel-batch-orders', ['private', 'spot'], 'POST', {'cost': 4})
    private_spot_post_trade_cancel_batch_orders_v2 = privateSpotPostTradeCancelBatchOrdersV2 = Entry('trade/cancel-batch-orders-v2', ['private', 'spot'], 'POST', {'cost': 4})
    private_spot_post_trade_orderinfo = privateSpotPostTradeOrderInfo = Entry('trade/orderInfo', ['private', 'spot'], 'POST', {'cost': 1})
    private_spot_post_trade_open_orders = privateSpotPostTradeOpenOrders = Entry('trade/open-orders', ['private', 'spot'], 'POST', {'cost': 1})
    private_spot_post_trade_history = privateSpotPostTradeHistory = Entry('trade/history', ['private', 'spot'], 'POST', {'cost': 1})
    private_spot_post_trade_fills = privateSpotPostTradeFills = Entry('trade/fills', ['private', 'spot'], 'POST', {'cost': 1})
    private_spot_post_trade_cancel_order_v2 = privateSpotPostTradeCancelOrderV2 = Entry('trade/cancel-order-v2', ['private', 'spot'], 'POST', {'cost': 2})
    private_spot_post_trade_cancel_symbol_order = privateSpotPostTradeCancelSymbolOrder = Entry('trade/cancel-symbol-order', ['private', 'spot'], 'POST', {'cost': 2})
    private_spot_post_wallet_transfer = privateSpotPostWalletTransfer = Entry('wallet/transfer', ['private', 'spot'], 'POST', {'cost': 4})
    private_spot_post_wallet_withdrawal = privateSpotPostWalletWithdrawal = Entry('wallet/withdrawal', ['private', 'spot'], 'POST', {'cost': 4})
    private_spot_post_wallet_subtransfer = privateSpotPostWalletSubTransfer = Entry('wallet/subTransfer', ['private', 'spot'], 'POST', {'cost': 10})
    private_spot_post_wallet_transfer_v2 = privateSpotPostWalletTransferV2 = Entry('wallet/transfer-v2', ['private', 'spot'], 'POST', {'cost': 4})
    private_spot_post_wallet_withdrawal_v2 = privateSpotPostWalletWithdrawalV2 = Entry('wallet/withdrawal-v2', ['private', 'spot'], 'POST', {'cost': 4})
    private_spot_post_wallet_withdrawal_inner_v2 = privateSpotPostWalletWithdrawalInnerV2 = Entry('wallet/withdrawal-inner-v2', ['private', 'spot'], 'POST', {'cost': 4})
    private_spot_post_plan_placeplan = privateSpotPostPlanPlacePlan = Entry('plan/placePlan', ['private', 'spot'], 'POST', {'cost': 1})
    private_spot_post_plan_modifyplan = privateSpotPostPlanModifyPlan = Entry('plan/modifyPlan', ['private', 'spot'], 'POST', {'cost': 1})
    private_spot_post_plan_cancelplan = privateSpotPostPlanCancelPlan = Entry('plan/cancelPlan', ['private', 'spot'], 'POST', {'cost': 1})
    private_spot_post_plan_currentplan = privateSpotPostPlanCurrentPlan = Entry('plan/currentPlan', ['private', 'spot'], 'POST', {'cost': 1})
    private_spot_post_plan_historyplan = privateSpotPostPlanHistoryPlan = Entry('plan/historyPlan', ['private', 'spot'], 'POST', {'cost': 1})
    private_mix_get_account_account = privateMixGetAccountAccount = Entry('account/account', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_account_accounts = privateMixGetAccountAccounts = Entry('account/accounts', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_account_accountbill = privateMixGetAccountAccountBill = Entry('account/accountBill', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_account_accountbusinessbill = privateMixGetAccountAccountBusinessBill = Entry('account/accountBusinessBill', ['private', 'mix'], 'GET', {'cost': 4})
    private_mix_get_account_open_count = privateMixGetAccountOpenCount = Entry('account/open-count', ['private', 'mix'], 'GET', {'cost': 1})
    private_mix_get_order_current = privateMixGetOrderCurrent = Entry('order/current', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_order_history = privateMixGetOrderHistory = Entry('order/history', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_order_detail = privateMixGetOrderDetail = Entry('order/detail', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_order_fills = privateMixGetOrderFills = Entry('order/fills', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_order_historyproducttype = privateMixGetOrderHistoryProductType = Entry('order/historyProductType', ['private', 'mix'], 'GET', {'cost': 8})
    private_mix_get_order_allfills = privateMixGetOrderAllFills = Entry('order/allFills', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_plan_currentplan = privateMixGetPlanCurrentPlan = Entry('plan/currentPlan', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_plan_historyplan = privateMixGetPlanHistoryPlan = Entry('plan/historyPlan', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_position_singleposition = privateMixGetPositionSinglePosition = Entry('position/singlePosition', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_position_allposition = privateMixGetPositionAllPosition = Entry('position/allPosition', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_trace_currenttrack = privateMixGetTraceCurrentTrack = Entry('trace/currentTrack', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_trace_followerorder = privateMixGetTraceFollowerOrder = Entry('trace/followerOrder', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_trace_historytrack = privateMixGetTraceHistoryTrack = Entry('trace/historyTrack', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_trace_summary = privateMixGetTraceSummary = Entry('trace/summary', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_trace_profitsettletokenidgroup = privateMixGetTraceProfitSettleTokenIdGroup = Entry('trace/profitSettleTokenIdGroup', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_trace_profitdategrouplist = privateMixGetTraceProfitDateGroupList = Entry('trace/profitDateGroupList', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_trade_profitdatelist = privateMixGetTradeProfitDateList = Entry('trade/profitDateList', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_trace_waitprofitdatelist = privateMixGetTraceWaitProfitDateList = Entry('trace/waitProfitDateList', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_trace_tradersymbols = privateMixGetTraceTraderSymbols = Entry('trace/traderSymbols', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_trace_traderlist = privateMixGetTraceTraderList = Entry('trace/traderList', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_trace_querytraceconfig = privateMixGetTraceQueryTraceConfig = Entry('trace/queryTraceConfig', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_get_order_margincoincurrent = privateMixGetOrderMarginCoinCurrent = Entry('order/marginCoinCurrent', ['private', 'mix'], 'GET', {'cost': 2})
    private_mix_post_account_setleverage = privateMixPostAccountSetLeverage = Entry('account/setLeverage', ['private', 'mix'], 'POST', {'cost': 8})
    private_mix_post_account_setmargin = privateMixPostAccountSetMargin = Entry('account/setMargin', ['private', 'mix'], 'POST', {'cost': 8})
    private_mix_post_account_setmarginmode = privateMixPostAccountSetMarginMode = Entry('account/setMarginMode', ['private', 'mix'], 'POST', {'cost': 8})
    private_mix_post_account_setpositionmode = privateMixPostAccountSetPositionMode = Entry('account/setPositionMode', ['private', 'mix'], 'POST', {'cost': 8})
    private_mix_post_order_placeorder = privateMixPostOrderPlaceOrder = Entry('order/placeOrder', ['private', 'mix'], 'POST', {'cost': 2})
    private_mix_post_order_batch_orders = privateMixPostOrderBatchOrders = Entry('order/batch-orders', ['private', 'mix'], 'POST', {'cost': 2})
    private_mix_post_order_cancel_order = privateMixPostOrderCancelOrder = Entry('order/cancel-order', ['private', 'mix'], 'POST', {'cost': 2})
    private_mix_post_order_cancel_all_orders = privateMixPostOrderCancelAllOrders = Entry('order/cancel-all-orders', ['private', 'mix'], 'POST', {'cost': 2})
    private_mix_post_order_cancel_batch_orders = privateMixPostOrderCancelBatchOrders = Entry('order/cancel-batch-orders', ['private', 'mix'], 'POST', {'cost': 2})
    private_mix_post_order_cancel_symbol_orders = privateMixPostOrderCancelSymbolOrders = Entry('order/cancel-symbol-orders', ['private', 'mix'], 'POST', {'cost': 2})
    private_mix_post_plan_placeplan = privateMixPostPlanPlacePlan = Entry('plan/placePlan', ['private', 'mix'], 'POST', {'cost': 2})
    private_mix_post_plan_modifyplan = privateMixPostPlanModifyPlan = Entry('plan/modifyPlan', ['private', 'mix'], 'POST', {'cost': 2})
    private_mix_post_plan_modifyplanpreset = privateMixPostPlanModifyPlanPreset = Entry('plan/modifyPlanPreset', ['private', 'mix'], 'POST', {'cost': 2})
    private_mix_post_plan_placetpsl = privateMixPostPlanPlaceTPSL = Entry('plan/placeTPSL', ['private', 'mix'], 'POST', {'cost': 2})
    private_mix_post_plan_placetrailstop = privateMixPostPlanPlaceTrailStop = Entry('plan/placeTrailStop', ['private', 'mix'], 'POST', {'cost': 2})
    private_mix_post_plan_placepositionstpsl = privateMixPostPlanPlacePositionsTPSL = Entry('plan/placePositionsTPSL', ['private', 'mix'], 'POST', {'cost': 2})
    private_mix_post_plan_modifytpslplan = privateMixPostPlanModifyTPSLPlan = Entry('plan/modifyTPSLPlan', ['private', 'mix'], 'POST', {'cost': 2})
    private_mix_post_plan_cancelplan = privateMixPostPlanCancelPlan = Entry('plan/cancelPlan', ['private', 'mix'], 'POST', {'cost': 2})
    private_mix_post_plan_cancelallplan = privateMixPostPlanCancelAllPlan = Entry('plan/cancelAllPlan', ['private', 'mix'], 'POST', {'cost': 2})
    private_mix_post_plan_cancelsymbolplan = privateMixPostPlanCancelSymbolPlan = Entry('plan/cancelSymbolPlan', ['private', 'mix'], 'POST', {'cost': 2})
    private_mix_post_trace_closetrackorder = privateMixPostTraceCloseTrackOrder = Entry('trace/closeTrackOrder', ['private', 'mix'], 'POST', {'cost': 2})
    private_mix_post_trace_setupcopysymbols = privateMixPostTraceSetUpCopySymbols = Entry('trace/setUpCopySymbols', ['private', 'mix'], 'POST', {'cost': 2})
    private_mix_post_trace_followersetbatchtraceconfig = privateMixPostTraceFollowerSetBatchTraceConfig = Entry('trace/followerSetBatchTraceConfig', ['private', 'mix'], 'POST', {'cost': 2})
    private_mix_post_trace_followerclosebytrackingno = privateMixPostTraceFollowerCloseByTrackingNo = Entry('trace/followerCloseByTrackingNo', ['private', 'mix'], 'POST', {'cost': 2})
    private_mix_post_trace_followerclosebyall = privateMixPostTraceFollowerCloseByAll = Entry('trace/followerCloseByAll', ['private', 'mix'], 'POST', {'cost': 2})
    private_mix_post_trace_followersettpsl = privateMixPostTraceFollowerSetTpsl = Entry('trace/followerSetTpsl', ['private', 'mix'], 'POST', {'cost': 2})
    private_p2p_get_merchant_merchantlist = privateP2pGetMerchantMerchantList = Entry('merchant/merchantList', ['private', 'p2p'], 'GET', {'cost': 1})
    private_p2p_get_merchant_merchantinfo = privateP2pGetMerchantMerchantInfo = Entry('merchant/merchantInfo', ['private', 'p2p'], 'GET', {'cost': 1})
    private_p2p_get_merchant_advlist = privateP2pGetMerchantAdvList = Entry('merchant/advList', ['private', 'p2p'], 'GET', {'cost': 1})
    private_p2p_get_merchant_orderlist = privateP2pGetMerchantOrderList = Entry('merchant/orderList', ['private', 'p2p'], 'GET', {'cost': 1})
