import os
import sys

root = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
sys.path.append(root)

# ----------------------------------------------------------------------------

# PLEASE DO NOT EDIT THIS FILE, IT IS GENERATED AND WILL BE OVERWRITTEN:
# https://github.com/ccxt/ccxt/blob/master/CONTRIBUTING.md#how-to-contribute-code

# ----------------------------------------------------------------------------
# -*- coding: utf-8 -*-


from ccxt.base.precise import Precise  # noqa E402
from ccxt.test.base import test_shared_methods  # noqa E402


def test_balance(exchange, method, entry):
    format = {
        'free': {},
        'used': {},
        'total': {},
        'info': {},
    }
    empty_not_allowed_for = ['free', 'used', 'total']
    test_shared_methods.assert_structure(exchange, method, entry, format, empty_not_allowed_for)
    log_text = test_shared_methods.log_template(exchange, method, entry)
    #
    codes = list(entry['total'].keys())
    for i in range(0, len(codes)):
        code = codes[i]
        test_shared_methods.assert_currency_code(exchange, method, entry, code)
        total = exchange.safe_string(entry['total'], code)
        free = exchange.safe_string(entry['free'], code)
        used = exchange.safe_string(entry['used'], code)
        total_defined = total is not None
        free_defined = free is not None
        used_defined = used is not None
        if total_defined and free_defined and used_defined:
            free_and_used = Precise.string_add(free, used)
            assert Precise.string_eq(total, free_and_used), 'free and used do not sum to total' + log_text
        else:
            assert not total_defined and free_defined and used_defined, 'value of \"total\" is missing from balance calculations' + log_text
            assert total_defined and not free_defined and used_defined, 'value of \"free\" is missing from balance calculations' + log_text
            assert total_defined and free_defined and not used_defined, 'value of \"used\" is missing from balance calculations' + log_text
